/// Generated By XFlutter Cli.
///
/// more info: https://medium.com/@aghiadodeh
import 'package:flutter/material.dart';
import 'package:flutterx_live_data/flutterx_live_data.dart';
import 'dart:async';
import 'package:flutter_mvvm_example/extensions/nullable_extensions.dart';
import 'package:flutter_mvvm_example/models/ui_models/ui_message.dart';

class SnackBarMessageListener extends StatefulWidget {
  final LiveData<UiMessage> uiMessage;
  const SnackBarMessageListener({required this.uiMessage, Key? key}) : super(key: key);

  @override
  State<SnackBarMessageListener> createState() => _SnackBarMessageListenerState();
}

class _SnackBarMessageListenerState extends State<SnackBarMessageListener> with StateObserver {
  @override
  Widget build(BuildContext context) {
    return const SizedBox.shrink();
  }

  @override
  FutureOr<void> registerObservers() {
    widget.uiMessage.observe(this, (value) {
      value.message?.let((it) => showSnackBar(context: context, message: it));
      value.message = null;
    });
  }
}

void showSnackBar({required BuildContext context, required String message, Function()? callback, TextStyle? textStyle}) {
  ScaffoldMessenger.of(context)
    ..hideCurrentSnackBar()
    ..showSnackBar(
      SnackBar(
        content: Text(message, style: textStyle),
        backgroundColor: Theme.of(context).colorScheme.onSurface,
        action: SnackBarAction(
          label: "Ok",
          onPressed: () {
            callback?.call();
          },
        ),
      ),
    );
}
